/*
Desenvolvedores: Evandro Mendonça - evandro.user@gmail.com
                 Mateus Pelegrino - mateuspelegrino@gmail.com
Colaboração: Esteban Clua, Marcelo Zamith, Calebe Tonassi, Elaine Cifoni.
*/

/*COMENTÁRIO DA CLASSE
  Essa classe cuida da interface dos níveis do jogo em si, ela muda o fundo e conta
 o tempo por exemplo. Em todo o decorrer do jogo, para os diversos níveis que o jogo
 tem, não são criados vários objetos Fase, apenas reutilizamos um mesmo objeto desta
 classe todo o tempo, alterando apenas seus atributos.*/

package aliensfront;

import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;
import java.sql.Time;
/*Importações de classes do JavaPlay, a primeira é usada para todo objeto do jogo,
 como personagens ou qualquer coisa que tenha um papel interativo no jogo. A segunda
 é usada para criar um Sprite, ou seja, um conjunto de desenhos que compõe o 
 personagem ou objeto.*/
import javaPlay.GameObject;
import javaPlay.Sprite;

public class Fase extends GameObject{

    private Sprite background;
    private static int nivelFase;
    /*Essa variável declara o número total de inimigos em cada fase do jogo.*/
    private int numeroInimigos;
    /*Obtivemos ajuda do Marcelo Zamith para fazer a parte da contagem do tempo
    no jogo.*/
    private Time tempoFinal = new Time(0,0,0);
    private float Tempo = 0.0f;
    private long TempoLong = 0;
        
    public Fase(){}

    /*Método step, tudo que está dentro desse método ocorerá a cada ciclo do jogo.*/
    public void step(long timeElapsed)
    {
        /*Código implementado pelo Marcelo Zamith, aqui se faz a contagem do tempo
         que fica sendo exibido na parte superior do jogo.*/
        Tempo += (float)timeElapsed / 1000.0f;
        if (Tempo > 1.0f)
        {
            TempoLong -= 10;
            tempoFinal.setTime(TempoLong);
            Tempo = 0.0f;
        }
        /*Final da implementação do Marcelo Zamith.*/
    }

    /*Método utilizado para preencher(desenhar) a tela do jogo com os respectivos
     desenhos e textos de cada fase.*/
    public void draw(Graphics g)
    {
        background.draw(g, 0, 0);
        g.setColor(Color.WHITE);
        g.setFont(new Font("Arial", Font.BOLD, 18));
        g.drawString("Nível: " + String.valueOf(nivelFase), 680, 61);
        g.setColor(Color.yellow);
        g.drawString("Tempo: " + tempoFinal.toString(), 340, 61);
        g.setColor(Color.WHITE);
    }

     public void avancaFase(){
        setNivelFase(getNivelFase() + 1);
    }

    public Sprite getBackground() {
        return background;
    }

    /*Esse método é utilizado para criar um novo sprite na fase (plano de fundo). É
     passado o arquivo em qual as imagens estão, o número de imagens que o arquivo
     contém e a altura e largura das imagens separadamente para que o JapaPlay possa
     "entender" a organização dos seus sprites.*/
    public void setBackground(String arquivo, int numeroSprites, int largura, int altura) {
        this.background = new Sprite(arquivo, numeroSprites, largura, altura);
    }

    public int getNivelFase() {
        return nivelFase;
    }

    /*Nesse método se faz a checagem de em que nível estamos, e caso mudamos de
     nível o método muda todos os atributos do objeto para que se adeque ao novo nível
     como dito na introdução da classe.*/
    public void setNivelFase(int nivelFase) {
        this.nivelFase = nivelFase;
        switch (nivelFase){
            case 1:
                setBackground("Terreno_Fase(1).png", 1, 800, 600);
                setNumeroInimigos(NumerosControle.INIMIGOS_FASE_1);
                setTempoFinal(0, 0, 20);
                break;
            case 2:
                setBackground("Terreno_Fase(2).png", 1, 800, 600);
                setNumeroInimigos(NumerosControle.INIMIGOS_FASE_2);
                setTempoFinal(0, 0, 20);
                break;
            case 3:
                setBackground("Terreno_Fase(3).png", 1, 800, 600);
                setNumeroInimigos(NumerosControle.INIMIGOS_FASE_3);
                setTempoFinal(0, 0, 20);
                break;
            case 4:
                setBackground("Terreno_Fase(4).png", 1, 800, 600);
                setNumeroInimigos(NumerosControle.INIMIGOS_FASE_4);
                setTempoFinal(0, 0, 20);
                break;
            case 5:
                setBackground("Terreno_Fase(5).png", 1, 800, 600);
                setNumeroInimigos(NumerosControle.INIMIGOS_FASE_5);
                setTempoFinal(0, 0, 40);
                break;
        }
    }

    public int getNumeroInimigos() {
        return numeroInimigos;
    }

    /*Aqui colocamos o número de inimigos que cada fase terá.*/
    public void setNumeroInimigos(int numeroInimigos) {
        this.numeroInimigos = numeroInimigos;
    }

    /*Nesse método colocamos o tempo que queremos que o nível dure.*/
    public void setTempoFinal(int horas, int minutos, int segundos){
       tempoFinal.setHours(horas);
       tempoFinal.setMinutes(minutos);
       tempoFinal.setSeconds(segundos);
       TempoLong = tempoFinal.getTime();
    }

    public long getTime(){
        return tempoFinal.getSeconds();
    }

}