/*
Desenvolvedores: Evandro Mendonça - evandro.user@gmail.com
                 Mateus Pelegrino - mateuspelegrino@gmail.com
Colaboração: Esteban Clua, Marcelo Zamith, Calebe Tonassi, Elaine Cifoni.
*/

package aliensfront;

import java.awt.Graphics;
import java.awt.Point;
/*Importações de classes do JavaPlay, a primeira é usada para todo objeto do jogo,
 como personagens ou qualquer coisa que tenha um papel interativo no jogo. A segunda
 é para colocarmos o Sprite no Player nesse caso. A terceira nos da o controle pelo
 teclado. E por fim a última é a classe principal do JavaPlay que permite visibilidade
 de outras classes da engine.*/
import javaPlay.GameObject;
import javaPlay.Sprite;
import javaPlay.Keyboard;
import javaPlay.GameEngine;

public class Player extends GameObject{

    private Sprite player;
    private int FrameAtual;
    private final int UP_FRAME = 12;
    private final int DOWN_FRAME = 0;
    private final int LEFT_FRAME = 4;
    private final int RIGHT_FRAME = 8;
    private int numeroSpriteAtual = 0;
    private int numeroVidas = 6;
    private static int numeroPontos = 0;
    private int playerEixo;
    private boolean ataqueDisponivel = true;
    private int contadorAtaque = 0;
    Keyboard k = new Keyboard();


    public Player(){}

    /*Construtor do player onde é passado pelo próprio construtor as posições x e y.*/
    public Player(int coordenadaX, int coordenadaY){
        this.x = coordenadaX;
        this.y = coordenadaY;
    }

    /*Método que ocorrerá a cada ciclo do jogo, ou seja, a cada passagem o player
     irá se mover e executar o método ataquePlayer.*/
    public void step(long timeElapsed) {
        movimentoDoPlayer();
        ataquePlayer();
    }

    public void setFrameAtual(int FrameAtual){
        this.FrameAtual = FrameAtual;
    }

    public int getFrameAtual(){
        return this.FrameAtual;
    }

    /*Método utilizado para preencher(desenhar) a tela do jogo com o personagem, o nome e a pontuação.*/
    public void draw(Graphics g) {
        player.setCurrAnimFrame(FrameAtual);
        player.draw(g, x, y);
        g.drawString("Marcus " +Integer.toString(numeroVidas) + "x", 80, 61);
        g.drawString("Pontuação: " + Integer.toString(numeroPontos), 60, 610);
    }

    public Sprite getPlayer(){
        return player;
    }

    /*Esse método é utilizado para criar um novo sprite no objeto player. É
     passado o arquivo em qual as imagens estão, o número de imagens que o arquivo
     contém, a largura e a altura das imagens separadamente para que o JavaPlay possa
     "entender" a organização dos seus sprites.*/
    public void setPlayer(String arquivo, int numeroSprites, int largura, int altura) {
        this.player = new Sprite(arquivo, numeroSprites, largura, altura);
    }

    public void setVidas(int vidas){
        numeroVidas = vidas;
    }

    public int getVidas(){
        return numeroVidas;
    }

    public int getNumeroPontos() {
        return numeroPontos;
    }

    public void setNumeroPontos(int numeroPontos) {
        this.numeroPontos = numeroPontos;
    }

    /*Aqui é fica onde a movimentação do player, vele lembrar que a movimentação
     do player é interativa, portanto se o jogador não apertar nenhuma tecla, nada
     acontecerá. Esse método verifica a tecla que o jogador apertou e agirá de
     acordo com a intenção do mesmo, movendo o personagem e organizando seu sprite,
     posição e sencação de movimento.*/
    public void movimentoDoPlayer(){
        k = GameEngine.getInstance().getKeyboard();
        //PERSONAGEM ANDANDO PARA BAIXO
        if((k.keyDown(Keyboard.DOWN_KEY))&&(this.y < NumerosControle.BORDA_INFERIOR - NumerosControle.ALTURA_PLAYER)){
            playerEixo = 0;
            this.y+=2;
            switch (numeroSpriteAtual){
                case DOWN_FRAME:
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                case (DOWN_FRAME + 1):
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                default:
                    this.setFrameAtual(DOWN_FRAME);
                    numeroSpriteAtual = DOWN_FRAME;
                    break;
            }
        }//Fim do if (BAIXO)
        //PERSONAGEM ANDANDO PARA CIMA
        if((k.keyDown(Keyboard.UP_KEY))&&(this.y > NumerosControle.BORDA_SUPERIOR)){
            playerEixo = 1;
            this.y-=2;
            switch (numeroSpriteAtual){
                case UP_FRAME:
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                case (UP_FRAME + 1):
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                default:
                    this.setFrameAtual(UP_FRAME);
                    numeroSpriteAtual = UP_FRAME;
                    break;
            }
        }//Fim do if (CIMA)
        //PERSONAGEM ANDANDO PARA A DIREITA
        if((k.keyDown(Keyboard.RIGHT_KEY))&&(this.x < NumerosControle.BORDA_DIREITA - NumerosControle.LARGURA_PLAYER)){
            playerEixo = 2;
            this.x+=2;
            switch (numeroSpriteAtual){
                case RIGHT_FRAME:
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                case (RIGHT_FRAME + 1):
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                default:
                    this.setFrameAtual(RIGHT_FRAME);
                    numeroSpriteAtual = RIGHT_FRAME;
                    break;
            }
        }//Fim do if (DIREITA)
        //PERSONAGEM ANDANDO PARA A ESQUERDA
        if((k.keyDown(Keyboard.LEFT_KEY))&&(this.x >NumerosControle.BORDA_ESQUERDA )){
            playerEixo = 3;
            this.x-=2;
            switch (numeroSpriteAtual){
                case LEFT_FRAME:
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                case (LEFT_FRAME + 1):
                    this.setFrameAtual(numeroSpriteAtual + 1);
                    numeroSpriteAtual++;
                    break;
                default:
                    this.setFrameAtual(LEFT_FRAME);
                    numeroSpriteAtual = LEFT_FRAME;
                    break;
            }
        }//Fim do if (ESQUERDA)
    }//Fim do método movimento do player

    /*Nesse método aconetece o mesmo que o método do movimento acima, mas aqui nós
     estamos implementando o ataque do player. Na metada do método há uma correção
     que tivemos que fazer para um problema que ocorria de o player poder atacar
     infinitamente, resolvemos deixar o comentário que fizemos quando estavamos
     programando para fins didáticos e abordagem das dificuldades.*/
    public boolean ataquePlayer(){
        k = GameEngine.getInstance().getKeyboard();
        
        if(ataqueDisponivel == true){

            if(k.keyDown(Keyboard.SPACE_KEY)){
                if((numeroSpriteAtual >= 0) &&(numeroSpriteAtual <= 3))
                    this.setFrameAtual(3);
                else
                    if((numeroSpriteAtual >= 4) &&(numeroSpriteAtual <= 6))
                        this.setFrameAtual(7);
                    else
                        if((numeroSpriteAtual >= 7) &&(numeroSpriteAtual <= 10))
                            this.setFrameAtual(11);
                        else
                            if((numeroSpriteAtual >= 12) &&(numeroSpriteAtual <= 14))
                                this.setFrameAtual(15);

                contadorAtaque += 1;    
                
                /*Correção do ataque infinito
                (correção para que o personagem após atacar, mesmo tendo o ataque
                 pressionado, não continue atacando infinitamente)*/
                if (contadorAtaque >= 10){
                    ataqueDisponivel = false;
                    contadorAtaque = 0;
                    if(this.getFrameAtual() == 3)
                        this.setFrameAtual(0);
                    else
                        if(this.getFrameAtual() == 7)
                            this.setFrameAtual(4);
                        else
                            if(this.getFrameAtual() == 11)
                                this.setFrameAtual(8);
                            else
                                if(this.getFrameAtual() == 15)
                                    this.setFrameAtual(12);
                }//FIM DA CORREÇÃO DO ATAQUE INFINITO

                return true;

            }else{
                this.setFrameAtual(numeroSpriteAtual);
                return false;
            }
        }

        if(ataqueDisponivel == false){
            if(!(k.keyDown(Keyboard.SPACE_KEY))){
                ataqueDisponivel = true;
                return false;
            }
        }

        return false;

    }

    /*Esse método verifica se o player colidiu com algum outro objeto qualquer do jogo.
     Na verdade o que o método faz realmente é ver se não colidiu, pois assim podemos
     separar o problema em menos casos ficamos assim mais fácil para a compreensão.*/
    public boolean playerColidiu(Point playerMin, Point playerMax, Point enemyMin, Point enemyMax){
        if(enemyMax.x <= playerMin.x || enemyMin.x >= playerMax.x){
                return false;
        }
        if(enemyMax.y <= playerMin.y || enemyMin.y >= playerMax.y){
            return false;
        }
        return true;
    }

    public int getEixo(){
        return playerEixo;
    }

}
