/*
Desenvolvedores: Evandro Mendonça - evandro.user@gmail.com
                 Mateus Pelegrino - mateuspelegrino@gmail.com
Colaboração: Esteban Clua, Marcelo Zamith, Calebe Tonassi, Elaine Cifoni.
*/

/* COMENTÁRIO DA CLASSE
	Esta classe faz a tela ganhar aparecer, caso o jogador ganhe o jogo.
*/
package aliensfront;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
/* Importações de classes do JavaPlay, a primeira é a classe que permite
 a execução lógica do jogo, dividindo a execução em tempos e permitindo o programador
 cuidar da lógica sob isso. A segunda é para colocarmos o Sprite no Player nesse caso. 
 A terceira nos da o controle pelo teclado. E por fim a última é a classe principal
 do JavaPlay que permite visibilidade de outras classes da engine.*/
import javaPlay.GameStateController;
import javaPlay.Sprite;
import javaPlay.Keyboard;
import javaPlay.GameEngine;

public class TelaGanhar implements GameStateController
{
    Sprite sprite;
    Player player = new Player();
    /*No método load fica tudo que será carregado quando for o método for chamado*/
    public void load()
    {
        sprite = new Sprite( "Tela_Ganhar.png", 1, 800, 600 );
    }

    public void step(long timeElapsed)
    {
    /*O step ficará correndo a cada ciclo, neste caso ele verifica se a tecla Esc foi pressionada,
	caso for verdade, o jogo é encerrado. Senão, ele verifica se a tecla Enter foi pressionada,
	caso for verdade, o menu aparece.*/
        Keyboard k = GameEngine.getInstance().getKeyboard();
        
        if (k.keyDown(Keyboard.ESCAPE_KEY))
        GameEngine.getInstance().requestShutdown();
        
        if( k.keyDown(Keyboard.ENTER_KEY)){
            GameEngine.getInstance().setStartingGameStateController(0);
            player.setNumeroPontos(0);
            GameEngine.getInstance().addGameStateController(NumerosControle.TELA_JOGO, new TelaJogar());
        }
    }
	/*Método draw é usado para preencher(desenhar) a tela ganhar. Ele também desenha na tela uma frase e a pontuação do jogador
	que no caso a fonte é Arial em negrito, de tamanho 18 e cor branca.*/
    public void draw(Graphics g)
    {
        sprite.draw(g, 0, 0);
        g.setColor(Color.WHITE);
        g.setFont(new Font("Arial", Font.BOLD, 18));
        g.drawString("Parabéns! Sua pontuação foi: " + Integer.toString(player.getNumeroPontos()), 250, 400);
    }

    public void unload() {
    }

    public void start() {
    }

    public void stop() {
    }

}
