/*
Desenvolvedores: Evandro Mendonça - evandro.user@gmail.com
                 Mateus Pelegrino - mateuspelegrino@gmail.com
Colaboração: Esteban Clua, Marcelo Zamith, Calebe Tonassi, Elaine Cifoni.
*/

/*COMENTÁRIO DA CLASSE
    Esta classe faz com que a tela de inicial do jogo(o menu principal) apareça no inicio
 do jogom permitindo você escolher entre as opções dispostas na tela, dentre elas começar o
 proprio jogo.
*/

package aliensfront;

import java.awt.Graphics;
import java.awt.Point;
/*Importações do JavaPlay. A primeira classe é a classe principal do JavaPlay que
 permite visibilidade de outras classes da engine. A segunda é a classe que permite
 a execução lógica do jogo, dividindo a execução em tempos e permitindo o programador
 cuidar da lógica sob isso. A classe Keyborad permite que usemos o teclado para
 controlar o jogo. A Mouse permite que usemos o mouse para controlar o jogo. E por
 fim a Sprite nos permite colocar imagens no jogo.*/
import javaPlay.GameEngine;
import javaPlay.GameStateController;
import javaPlay.Keyboard;
import javaPlay.Mouse;
import javaPlay.Sprite;

class TelaIniciar implements GameStateController{

    private Sprite menu;
    private int telaAtual = 0;
    /*Essa variável dirá se o jogador está na tela principal, quando estiver como 0,
     ou em outra tela qualquer, quando estiver como 1. Isso auxilia na observação de
     qual das telas o jogador se encontra, e assim podemos resolver o problema de
     os botões serem apenas areas clicáveis, permitindo o clique em telaAtual = 0, e
     desabilitando em 1.*/

    public TelaIniciar() {}

    /*No método load fica tudo que será carregado no começo da aplicação, antes
     de tudo.*/
    public void load() {
        menu = new Sprite("MENU.png", 1, 800, 600 );
    }

    /*O step ficará correndo a cada ciclo, nesse caso aqui ele nao faz nada de especial
     a não ser esperar a interação do usuário.*/
    public void step(long timeElapsed) {
        Mouse m = GameEngine.getInstance().getMouse();
        Keyboard k = GameEngine.getInstance().getKeyboard();

        if((m.isLeftButtonPressed() == true)&&(telaAtual == 0)){
            Point p  = m.getMousePos();
            //POSIÇÃO DO BOTÃO START
            if((p.x >= 310) && (p.y >= 155) && (p.x <= 485) && (p.y <= 215)){
                GameEngine.getInstance().setNextGameStateController(NumerosControle.TELA_JOGO);
            }
            //POSIÇÃO DO BOTÃO INSTRUÇÕES
            if((p.x >= 310) && (p.y >= 240) && (p.x <= 485) && (p.y <= 300)){
                menu = new Sprite("INSTRUCOES.png", 1, 800, 600);
                telaAtual = 1;
            }
            //POSIÇÃO DO BOTÃO HISTÓRIA
            if((p.x >= 310) && (p.y >= 330) && (p.x <= 485) && (p.y <= 385)){
                menu = new Sprite("HISTORIA.png", 1, 800, 600);
                telaAtual = 1;
            }
            //POSIÇÃO DO BOTÃO CREDITOS
            if ((p.x >= 310) && (p.y >= 413) && (p.x <= 485) && (p.y <= 470)){
                menu = new Sprite("CREDITOS.png", 1, 800, 600);
                telaAtual = 1;
            } 
        }
        //Se em qualquer das telas, for apertado a tecla ESC, retorna a tela menu principal
        if(k.keyDown(Keyboard.ESCAPE_KEY)){
             menu = new Sprite("MENU.png", 1, 800, 600);
             telaAtual = 0;
             /*Aqui podemos ver o retorno da variável ao seu valor inicial, retomando
             o direito de escolha do usuário para cliques com o mouse, conforme a
             verificação do IF acima.*/
        }
    } 

    /*Método draw usado para desenhar o menu na tela do jogo.*/
    public void draw(Graphics g) {
        menu.draw(g, 0, 0);
    }

    public void unload() {}

    public void start() {}

    public void stop() {}

}
