/*
Desenvolvedores: Evandro Mendonça - evandro.user@gmail.com
                 Mateus Pelegrino - mateuspelegrino@gmail.com
Colaboração: Esteban Clua, Marcelo Zamith, Calebe Tonassi, Elaine Cifoni.
*/

/* COMENTÁRIO DA CLASSE
	Esta classe faz a tela perder aparecer, caso o jogador perca o jogo por qualquer motivo.
*/
package aliensfront;

import java.awt.Graphics;
/* Importações de classes do JavaPlay, a primeira é a classe que permite
 a execução lógica do jogo, dividindo a execução em tempos e permitindo o programador
 cuidar da lógica sob isso. A segunda é para colocarmos o Sprite no Player nesse caso. 
 A terceira nos da o controle pelo teclado. E por fim a última é a classe principal
 do JavaPlay que permite visibilidade de outras classes da engine.*/
import javaPlay.GameStateController;
import javaPlay.Sprite;
import javaPlay.Keyboard;
import javaPlay.GameEngine;


public class TelaPerder implements GameStateController
{
    Sprite sprite;
    Player player = new Player();
    /*No método load fica tudo que será carregado quando for o método for chamado*/
	public void load() {
         sprite = new Sprite( "Tela_Perder.png", 1, 800, 600 );
    }
	/*O step ficará correndo a cada ciclo, neste caso ele verifica se a tecla Esc foi pressionada,
	caso for verdade, o jogo é encerrado. Senão, ele verifica se a tecla Enter foi pressionada,
	caso for verdade, o menu aparece.*/
    public void step(long timeElapsed)
    {
        Keyboard k = GameEngine.getInstance().getKeyboard();

        if (k.keyDown(Keyboard.ESCAPE_KEY))
            GameEngine.getInstance().requestShutdown();
        else if( k.keyDown(Keyboard.ENTER_KEY)){
            GameEngine.getInstance().setStartingGameStateController(0);
            player.setNumeroPontos(0);
            GameEngine.getInstance().addGameStateController(NumerosControle.TELA_JOGO, new TelaJogar());

        }
    }
	/*Método draw é usado para desenhar a tela perder.*/
    public void draw(Graphics g)
    {
        sprite.draw(g, 0, 0);
    }

    public void unload() {
    }

    public void start() {
    }

    public void stop() {
    }
}
