/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bublesortanimado;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import javaPlay.GameEngine;
import javaPlay.GameStateController;
import javaPlay.Keyboard;
import javaPlay.Sprite;

/**
 *
 * @author eu
 */
public class ControleFase implements GameStateController
{  
    private Keyboard keyboard;

    private int TAM_SEQUENCIA;
    private Numero sequenciaOriginal[];
    private Numero sequenciaGerada[];

    private int QUANT_MENSAGENS;
    private Mensagem[] mensagens;

    private boolean ordenarSequencia;
    private boolean enterPressionado;
    private int numeroTrocasOcorridas;


    public void load()
    {   
            this.keyboard = GameEngine.getInstance().getKeyboard();

            this.QUANT_MENSAGENS = 7;
            this.mensagens = new Mensagem[QUANT_MENSAGENS];
            this.mensagens[0] = new Mensagem(150, 530, "Aperte ENTER para gerar uma nova sequência.", Color.WHITE);
            this.mensagens[1] = new Mensagem(150, 550, "A cada nova sequência gerada a mesma será ordenada.", Color.WHITE);
            this.mensagens[2] = new Mensagem(150, 480,"", Color.WHITE);
            this.mensagens[3] = new Mensagem(30, 160, "Original:", Color.WHITE);
            this.mensagens[4] = new Mensagem(30, 360, "Gerada:", Color.WHITE);
            this.mensagens[5] = new Mensagem(250, 60, "Trocando Números e Ordenando", Color.YELLOW);
            this.mensagens[6] = new Mensagem(150, 580, "Pressione ESC para Sair.", Color.WHITE);

            Dimension dimensaoSprite = new Dimension(80,72);
            this.TAM_SEQUENCIA = 14;
            this.sequenciaOriginal = new Numero[TAM_SEQUENCIA];
            for ( int i = 0; i < TAM_SEQUENCIA; i++ )
            {
                int numeroDaFigura = i + 1;
                sequenciaOriginal[i] = new Numero(numeroDaFigura);
                sequenciaOriginal[i].setDimensao(dimensaoSprite);
                sequenciaOriginal[i].setSprite( new Sprite("imagens/" + numeroDaFigura + ".png", 1, dimensaoSprite.width, dimensaoSprite.height) );
            }

            sequenciaGerada = sequenciaOriginal;
    }

    public void unload()
    {
        this.keyboard = null;
        this.sequenciaOriginal = null;
        this.sequenciaGerada = null;
        this.mensagens = null;
    }

    public void start() {
        
    }

    //Gera uma nova sequência em ordem aleatória
    private void gerarNovaSequancia( )
    {
            int contadorGerados = 0;
            while (contadorGerados < TAM_SEQUENCIA)
            {
                    int valorGerado = (int) (Math.random()*100);
                    if ( (valorGerado > contadorGerados-1) && ( valorGerado < TAM_SEQUENCIA) )
                    {
                        Numero temp = sequenciaOriginal[valorGerado];
                        sequenciaOriginal[valorGerado] = sequenciaOriginal[contadorGerados];
                        sequenciaOriginal[contadorGerados] = temp;
                        contadorGerados++;
                    }
            }
    }

    private void bolha()
    {       
            // inicialização de dados            
            int i , j;
            Numero aux;
            numeroTrocasOcorridas = 0;
            
            for ( i=0; i < TAM_SEQUENCIA; i++)
            {
                 for ( j = i+1; j < TAM_SEQUENCIA; j++)
                 {
                         if ( sequenciaOriginal[i].getValor() > sequenciaOriginal[j].getValor() )
                            {
                                   aux = sequenciaOriginal[i];
                                   sequenciaOriginal[i] = sequenciaOriginal[j];
                                   sequenciaOriginal[j] = aux;
                                   numeroTrocasOcorridas++;
                            }
                 }
            }

    }

    private boolean temQueGerarNovaSequancia()
    {

        //Verifica se a tecla ENTER  está pressionada
        //Como a o tempo necessário para você PRESSIONAR e SOLTAR a tecla ENTER é
        //é muito grande quardamos o estado que ela está pressionada
        if ( keyboard.keyDown(Keyboard.ENTER_KEY) == true )
            enterPressionado = true;

        //Agora que sabemos que você pressionou a tecla enter
        //Precisamos saber se você deixou de pressiná-la, só ai teremos a confirmação que você quer
        //que uma nova sequência de números seja gerada
        if( (enterPressionado == true) && (keyboard.keyDown(Keyboard.ENTER_KEY) == false) )
        {
            enterPressionado = false;
            return true;
        }

        return false;
    }

    public void step(long timeElapsed)
    {
            if ( temQueGerarNovaSequancia() == true )
            {
                gerarNovaSequancia();
                sequenciaGerada = sequenciaOriginal.clone();
                ordenarSequencia = true;
            }

            if ( ordenarSequencia == true )
            {
                bolha();
                mensagens[2].setMensagem("Foram necessárias " + numeroTrocasOcorridas + " trocas para obter a sequência original.");
                ordenarSequencia = false;
            }

            //Se ( TECLA_ESC.estáPressionada == true )
            //   Encerrar animação

            if ( keyboard.keyDown( Keyboard.ESCAPE_KEY) == true )
                GameEngine.getInstance().requestShutdown();
    }

    public void drawSequencia(Graphics g, int xInicial, int yInicial,  Numero[] sequencia)
    {
            int x = xInicial;
            int y = yInicial;
            for ( int i =0; i < TAM_SEQUENCIA; i++)
            {
                    sequencia[i].setPosicao(x, y);
                    sequencia[i].draw(g);

                    Dimension d = sequencia[i].getDimensao();
                    x += d.width + 10; // O incremento aqui é para afastar o próximo sprite do anterior

                    //Como só cabem 8 sprites em uma única linha na tela
                    //Quando tivermos i = 7, teremos 8 sprites, já que a contagem começa de zero,
                    //icrementaremos o valor de y com a altura do sprite + 5 unidades
                    if ( (i+1) % 7 == 0 )
                    {
                        y += d.height + 5;
                        x = xInicial;
                    }
            }
    }

    public void draw(Graphics g)
    {
            g.setColor(Color.BLACK);
            g.fillRect(0, 0, 800, 600);

            for ( int i = 0; i < QUANT_MENSAGENS; i++) mensagens[i].draw(g);

            drawSequencia(g, 120, 50, sequenciaOriginal);
            drawSequencia(g, 120, 250, sequenciaGerada);
    }

    public void stop() {
        
    }

}
