/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package extendjavaplay;

import java.awt.Dimension;
import java.awt.Point;

/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense
 * Ciência da Computação
 */

public class MouseClick
{
    private static javaPlay.Mouse mouse = null;

    private boolean pressionouBotaoEsquerdo;
    private boolean pressionouBotaoDireito;
    private boolean pressionouBotaoCentral;

    public MouseClick( javaPlay.Mouse m )
    {
        MouseClick.mouse = m;
    }

    public boolean botaoEsquerdoPressionado()
    {
        return mouse.isLeftButtonPressed();
    }

    public boolean botaoDireitoPressionado()
    {
        return mouse.isRightButtonPressed();
    }

    public boolean botaoCentralPressionado()
    {
        return mouse.isMiddleButtonPressed();
    }

    public boolean clicouDireito()
    {
            if ( mouse.isRightButtonPressed() ) pressionouBotaoDireito = true;

            if (pressionouBotaoDireito && (mouse.isRightButtonPressed() == false) )
            {
               pressionouBotaoDireito = false;
               return true;
            }

            return false;
    }

    public boolean clicouCentral()
    {
            if ( mouse.isMiddleButtonPressed() ) pressionouBotaoCentral = true;

            if (pressionouBotaoCentral && (mouse.isMiddleButtonPressed() == false) )
            {
               pressionouBotaoCentral = false;
               return true;
            }

            return false;
    }

    public boolean clicouEsquerdo()
    {
            if ( mouse.isLeftButtonPressed() ) pressionouBotaoEsquerdo = true;

            if (pressionouBotaoEsquerdo && (mouse.isLeftButtonPressed() == false) )
            {
               pressionouBotaoEsquerdo = false;
               return true;
            }

            return false;
    }

    public boolean sobreObjeto( Objeto objeto )
    {
            Point pM = (Point) mouse.getMousePos().clone();
            pM.y -= 30;//O 30 corresponde ao valor tomado pela borda da janela em relação ao eixo Y
            pM.x -= 8;// O 8 corresponde ao valor tomado pela borda da janela em relação ao eixo X

            //Verifica se está fora dos limites no eixo X para o mouse

            Dimension d = objeto.getDimensao();
            if ( (pM.x < objeto.x) || ( pM.x > objeto.x + d.width) )
                return false;

            //Verifica se está fora dos limites no eixo Y para o mouse
            if ( (pM.y < objeto.y) || (pM.y > objeto.y + d.height ) )
                return false;

            //Os outros testes falharam, quer dizer o mouse está sobre a área do botão
            return true;            
    }

        public Point getPosicao()
    {
        Point ponto = (Point) mouse.getMousePos().clone();
        ponto.y -= 30;//O 30 corresponde ao valor tomado pela borda da janela em relação ao eixo Y
        ponto.x -= 8;// O 8 corresponde ao valor tomado pela borda da janela em relação ao eixo X
        return ponto;
    }
}
