/*
 * Game Object: Score
 */

package extendjavaplay;

import java.awt.Color;
import java.awt.Graphics;
import javaPlay.GameObject;
import java.awt.Font;

/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense
 * Ciência da Computação
 */

public class Score extends GameObject
{
    //pontuação
    private int scoreCounter;

    //Mensagem que será exibida na tela
    private String mensagem;

    //Cor com a qual a mensagem será exibida
    private Color cor;

    public Score ( int valorInicialScore, int x, int y, String mensagem, Color cor )
    {
        scoreCounter = valorInicialScore;
        this.x = x;//Posição no eixo X onde a mensagem será desenhada
        this.y = y;//Posição no eixo Y onde a mensagem será desenhada
        this.mensagem = mensagem;
        this.cor = cor;
    }

    //Retorna o a pontuação
    public int getScore(){
        return scoreCounter;
    }

    //Seta um valor para o score, se for passado um valor negativo o valor da pontuação diminuíra
    //já se for uma valor positivo então a pontuação aumentará
    public void setScore( int n ){
        scoreCounter += n;
    }

    public void step(long timeElapsed){ /*Método vazio*/}

    //Desenha os atributos da classe na tela
    public void draw(Graphics g)
    {
        g.setColor(cor);
        g.setFont(new Font("Arial", Font.BOLD, 18));

        //desenha uma String na tela na posicao (80,110)
        g.drawString(mensagem + scoreCounter, x, y);
    }
}