package extendjavaplay;

/*
 * Game Object: Score
 */

import java.awt.Color;
import java.awt.Graphics;
import javaPlay.GameObject;
import java.awt.Font;

/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense
 * Ciência da Computação
 */

public class Texto extends GameObject
{
    //Mensagem que será exibida na tela
    private String frase;

    private Font fonte;

    //Cor com a qual a mensagem será exibida
    private Color cor;

    public Texto ( int x, int y, String mensagem, Color cor )
    {
        this.x = x;//Posição no eixo X onde a mensagem será desenhada
        this.y = y;//Posição no eixo Y onde a mensagem será desenhada
        this.cor = cor;
        this.frase = mensagem;
        this.fonte = new Font("Arial", Font.BOLD, 18);
    }

    public void setConteudo( String str )
    {
        this.frase = str;
    }

    public String getConteudo()
    {
        return  this.frase;
    }

    public void setFonte( Font fonte )
    {
        this.fonte = fonte;
    }

    public void step(long timeElapsed){
        //Método vazio
    }

    //Desenha os atributos da classe na tela
    public void draw(Graphics g)
    {
            g.setColor(cor);
            g.setFont(fonte);

            //desenha uma String na tela na posicao (80,110)
            g.drawString(frase , x, y);
    }

}